/****
A simple program capture images from a usb camera
Along with a mouse track function, find mouse position
and draw a green dot on the image
***/

#include "cv.h" 
#include "highgui.h" 
#include <iostream>

using namespace std;

char img_name[]="AviTest"; 
IplImage* img=0;
IplImage* frame=0; 
CvCapture* capture=0; 
CvVideoWriter* writer=0; 

CvPoint pt;

void on_mouse(int event, int x, int y, int flags, void* param ) { 
    if (event==CV_EVENT_LBUTTONDOWN) { 
		pt = cvPoint(x, img->height - y);
    } 
} 

int main(void) { 

    //initialize device
	CvCapture* capture = 0;
	capture = cvCreateCameraCapture(0);

	//initialize image
	img = cvCreateImage(cvSize(320, 240), IPL_DEPTH_8U, 3);

	//initialize window
    cvNamedWindow(img_name,  CV_WINDOW_AUTOSIZE); 

	//generate a blank image
    cvShowImage(img_name, img); 

	//initialize a writer
    writer=cvCreateVideoWriter("AviTest.avi", -1, 15, cvGetSize(img)); 

    //bind mouse callback
    cvSetMouseCallback(img_name, &on_mouse);
	char c = cvWaitKey(1);

	// loop, capture image sequences
	while( (char)c != 'q')
	{
		//capture frame
		img=cvQueryFrame(capture);
		cvCircle(img, pt, 3, CV_RGB(0,255,0), -1, 8,0);

		//show image on windows
		cvShowImage(img_name, img);
		
		//Resize captured image into 320x240 and adjust the image by fliping the coordinate.
		frame=cvCreateImage(cvSize(320, 240), IPL_DEPTH_8U, 3);
		cvResize(img, frame, 1);
		cvFlip(frame, frame, 0);

		//save frame into wrtier
		cvWriteFrame(writer, frame);

		//Wait 20 millisecond for a key action
		c = cvWaitKey(20);
	}

    // "cleanup" 
    cvReleaseVideoWriter(&writer); 
    cvDestroyAllWindows(); 

	return (0);

} 
